Nathan-Yang
2017-07-14 08:52
采纳率: 33.3%
浏览 2.2k
已采纳

java 异常和return的执行

public class Test1{

public String testt() throws Exception{
    try {
        int i = 9/0;
    } catch (Exception e) {
        throw e;
    }finally{
        return "test1";
    }
}

}


public class Test2 {
    public static void main(String[] args) {
        Test1 t = new Test1();
        String str = "test2";
        try{
            str = t.testt();
            System.out.println(str);
        }catch(Exception e){
            System.out.println(str);
        }

    }
}

上述代码输出“test1”,有没有大神出来解释下为什么Test2里面的catch没有进去?

  • 写回答
  • 好问题 提建议
  • 追加酬金
  • 关注问题
  • 邀请回答

5条回答 默认 最新

  • IAmObject 2017-07-14 09:31
    最佳回答

    你的testt()方法写了finally的,finally是无论如何都会执行的代码块,对于Test2 中的str 得到值的过程并没有出现异常,所以不会进入到catch代码块里面的

    评论
    解决 无用
    打赏 举报
查看更多回答(4条)

相关推荐 更多相似问题